# mypy: disable-error-code="misc, override, no-redef"

import Boost.Python
import pxr.Sdf
import pxr.Tf
import pxr.Usd
from typing import Any, ClassVar, overload

__MFB_FULL_PACKAGE_NAME: str

class DenoisePass(pxr.Usd.Typed):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    @staticmethod
    def Define(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> DenoisePass: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> DenoisePass: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...

class Pass(pxr.Usd.Typed):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def CreateCommandAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateDenoiseEnableAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateDenoisePassRel(self) -> pxr.Usd.Relationship: ...
    def CreateFileNameAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateInputPassesRel(self) -> pxr.Usd.Relationship: ...
    def CreatePassTypeAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateRenderSourceRel(self) -> pxr.Usd.Relationship: ...
    @staticmethod
    def Define(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> Pass: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> Pass: ...
    def GetCommandAttr(self) -> pxr.Usd.Attribute: ...
    def GetDenoiseEnableAttr(self) -> pxr.Usd.Attribute: ...
    def GetDenoisePassRel(self) -> pxr.Usd.Relationship: ...
    def GetFileNameAttr(self) -> pxr.Usd.Attribute: ...
    def GetInputPassesRel(self) -> pxr.Usd.Relationship: ...
    def GetPassTypeAttr(self) -> pxr.Usd.Attribute: ...
    def GetRenderSourceRel(self) -> pxr.Usd.Relationship: ...
    def GetRenderVisibilityCollectionAPI(self) -> pxr.Usd.CollectionAPI: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...

class Product(SettingsBase):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def CreateOrderedVarsRel(self) -> pxr.Usd.Relationship: ...
    def CreateProductNameAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateProductTypeAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    @staticmethod
    def Define(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> Product: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> Product: ...
    def GetOrderedVarsRel(self) -> pxr.Usd.Relationship: ...
    def GetProductNameAttr(self) -> pxr.Usd.Attribute: ...
    def GetProductTypeAttr(self) -> pxr.Usd.Attribute: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...

class Settings(SettingsBase):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def CreateIncludedPurposesAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateMaterialBindingPurposesAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateProductsRel(self) -> pxr.Usd.Relationship: ...
    def CreateRenderingColorSpaceAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    @staticmethod
    def Define(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> Settings: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> Settings: ...
    def GetIncludedPurposesAttr(self) -> pxr.Usd.Attribute: ...
    def GetMaterialBindingPurposesAttr(self) -> pxr.Usd.Attribute: ...
    def GetProductsRel(self) -> pxr.Usd.Relationship: ...
    def GetRenderingColorSpaceAttr(self) -> pxr.Usd.Attribute: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    @staticmethod
    def GetStageRenderSettings(arg1: pxr.Usd.Stage) -> Settings: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...

class SettingsBase(pxr.Usd.Typed):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def CreateAspectRatioConformPolicyAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateCameraRel(self) -> pxr.Usd.Relationship: ...
    def CreateDataWindowNDCAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateDisableDepthOfFieldAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateDisableMotionBlurAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateInstantaneousShutterAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreatePixelAspectRatioAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateResolutionAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> SettingsBase: ...
    def GetAspectRatioConformPolicyAttr(self) -> pxr.Usd.Attribute: ...
    def GetCameraRel(self) -> pxr.Usd.Relationship: ...
    def GetDataWindowNDCAttr(self) -> pxr.Usd.Attribute: ...
    def GetDisableDepthOfFieldAttr(self) -> pxr.Usd.Attribute: ...
    def GetDisableMotionBlurAttr(self) -> pxr.Usd.Attribute: ...
    def GetInstantaneousShutterAttr(self) -> pxr.Usd.Attribute: ...
    def GetPixelAspectRatioAttr(self) -> pxr.Usd.Attribute: ...
    def GetResolutionAttr(self) -> pxr.Usd.Attribute: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...

class Tokens(Boost.Python.instance):
    RenderDenoisePass: ClassVar[str] = ...  # read-only
    RenderPass: ClassVar[str] = ...  # read-only
    RenderProduct: ClassVar[str] = ...  # read-only
    RenderSettings: ClassVar[str] = ...  # read-only
    RenderSettingsBase: ClassVar[str] = ...  # read-only
    RenderVar: ClassVar[str] = ...  # read-only
    adjustApertureHeight: ClassVar[str] = ...  # read-only
    adjustApertureWidth: ClassVar[str] = ...  # read-only
    adjustPixelAspectRatio: ClassVar[str] = ...  # read-only
    aspectRatioConformPolicy: ClassVar[str] = ...  # read-only
    camera: ClassVar[str] = ...  # read-only
    collectionRenderVisibilityIncludeRoot: ClassVar[str] = ...  # read-only
    color3f: ClassVar[str] = ...  # read-only
    command: ClassVar[str] = ...  # read-only
    cropAperture: ClassVar[str] = ...  # read-only
    dataType: ClassVar[str] = ...  # read-only
    dataWindowNDC: ClassVar[str] = ...  # read-only
    denoiseEnable: ClassVar[str] = ...  # read-only
    denoisePass: ClassVar[str] = ...  # read-only
    disableDepthOfField: ClassVar[str] = ...  # read-only
    disableMotionBlur: ClassVar[str] = ...  # read-only
    expandAperture: ClassVar[str] = ...  # read-only
    fileName: ClassVar[str] = ...  # read-only
    full: ClassVar[str] = ...  # read-only
    includedPurposes: ClassVar[str] = ...  # read-only
    inputPasses: ClassVar[str] = ...  # read-only
    instantaneousShutter: ClassVar[str] = ...  # read-only
    intrinsic: ClassVar[str] = ...  # read-only
    lpe: ClassVar[str] = ...  # read-only
    materialBindingPurposes: ClassVar[str] = ...  # read-only
    orderedVars: ClassVar[str] = ...  # read-only
    passType: ClassVar[str] = ...  # read-only
    pixelAspectRatio: ClassVar[str] = ...  # read-only
    preview: ClassVar[str] = ...  # read-only
    primvar: ClassVar[str] = ...  # read-only
    productName: ClassVar[str] = ...  # read-only
    productType: ClassVar[str] = ...  # read-only
    products: ClassVar[str] = ...  # read-only
    raster: ClassVar[str] = ...  # read-only
    raw: ClassVar[str] = ...  # read-only
    renderSettingsPrimPath: ClassVar[str] = ...  # read-only
    renderSource: ClassVar[str] = ...  # read-only
    renderVisibility: ClassVar[str] = ...  # read-only
    renderingColorSpace: ClassVar[str] = ...  # read-only
    resolution: ClassVar[str] = ...  # read-only
    sourceName: ClassVar[str] = ...  # read-only
    sourceType: ClassVar[str] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...

class Var(pxr.Usd.Typed):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def CreateDataTypeAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateSourceNameAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateSourceTypeAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    @staticmethod
    def Define(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> Var: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> Var: ...
    def GetDataTypeAttr(self) -> pxr.Usd.Attribute: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    def GetSourceNameAttr(self) -> pxr.Usd.Attribute: ...
    def GetSourceTypeAttr(self) -> pxr.Usd.Attribute: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...
